summaryrefslogtreecommitdiff
path: root/Biz/Cloud/post-receive.bash
diff options
context:
space:
mode:
authorBen Sima <ben@bsima.me>2023-10-10 13:15:59 -0400
committerBen Sima <ben@bsima.me>2023-10-10 13:15:59 -0400
commit904de577261e7024373e7a42fd763184764238f9 (patch)
tree563e4968eab568466ae3e7a1c747dd24a77986c0 /Biz/Cloud/post-receive.bash
parent6107f8178e26ada67e5d5ec60501e24528b3db56 (diff)
Don't swallow namespace-parsing errors
Previously, if there was a problem with the inputs and bild failed to determine the namespace, 'fromPath' would return 'Nothing' and then 'catMaybes' would drop the error-causing input altogether. In the one time that I had a bad input, this made debugging incredibly difficult. It's always a bad idea to swallow errors silently, so instead lets just kill the program if we have bad inputs.
Diffstat (limited to 'Biz/Cloud/post-receive.bash')
-rwxr-xr-xBiz/Cloud/post-receive.bash39
1 files changed, 39 insertions, 0 deletions
diff --git a/Biz/Cloud/post-receive.bash b/Biz/Cloud/post-receive.bash
new file mode 100755
index 0000000..4a67043
--- /dev/null
+++ b/Biz/Cloud/post-receive.bash
@@ -0,0 +1,39 @@
+#!/usr/bin/env bash
+#
+# creates an archive of a git repo on push
+#
+# unfortunately the nixos gitolite module does not copy the 'commonHooks'
+# properly, so we have to manually deploy this like so:
+#
+# scp Biz/Cloud/post-receive \
+# root@simatime.com:/srv/git/.gitolite/hooks/common/post-receive
+#
+# One time only:
+#
+# ssh root@simatime.com "sudo -u git gitolite setup -ho"
+#
+# Also on first-time setup, might need to manually check the permissions are
+# correct on $webroot/archive or wherever else.
+#
+set -euo pipefail
+while read oldrev newrev refname
+do
+ if [[ -e ./git-daemon-export-ok ]]
+ then
+ repo=$(basename $PWD | sed 's/.git//g')
+ branch=$(git rev-parse --symbolic --abbrev-ref $refname)
+ webroot="/srv/www/simatime.com/"
+ outdir="$webroot/archive/$repo/$branch"
+ mkdir -p $outdir
+ echo " making: https://simatime.com/archive/$repo/$branch/$newrev.tar.gz"
+ git archive "$branch" --prefix "$repo-$branch/" --format tar \
+ | gzip > "$outdir/$newrev.tar.gz"
+ echo " making: https://simatime.com/archive/$repo/$branch/$newrev.sha256"
+ hash=$(nix-prefetch-url --unpack file://$outdir/$newrev.tar.gz 2>/dev/null)
+ echo "$hash" > "$outdir/$newrev.sha256"
+ echo " commit: $newrev"
+ echo " sha256: $hash"
+ echo " in biz: deps update $repo --branch $branch --rev $newrev --attribute sha256=$hash"
+ chmod -R 755 "$webroot/archive"
+ fi
+done